﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EntityFrameWorkLearning
{
    class Program
    {
        static void Main(string[] args)
        {
            using (var oAWEntities = new AdventureWorksEntities())
            {
                // 1. Example from the last part
                //    Select all products without any constraints
                //var query = from p in oAWEntities.Product
                //            select p;

                // 2. Example with additional constraints
                //    Select all products that are Mountain Bikes, that have
                //    a list price above 0 and order them by list price in 
                //    descending order
                //var query = from p in oAWEntities.Product
                //            where p.ProductSubcategory.Name == "Mountain Bikes"
                //                && p.ListPrice > 0
                //            orderby p.ListPrice descending
                //            select p;

                // 3. Example using Lambda Expressions
                //    Select all products that have a review rating above 3
                var query = from p in oAWEntities.Product
                            where p.ProductReview.Any(pr => pr.Rating > 3)
                            select p;

                foreach (var product in query.Take(20))
                {
                    Console.WriteLine(string.Format("{0} | {1} | {2}",
                        product.ProductID, product.Name, product.ListPrice));
                }

                Console.ReadLine();
                Console.Clear();

                var oQuery = (System.Data.Objects.ObjectQuery<Product>) query;
                Console.WriteLine(oQuery.ToTraceString());
                Console.ReadLine();
            }
        }
    }
}
